<template>
  <div
    v-show="isCreatingDocument || isAllCorrectionsWithDocument"
    class="correction-document"
  >
    <ObButton
      v-if="isCreatingDocument"
      label="Cформировать и отправить корректировочный документ"
      :mini="isMini"
      :class="{
        '--mini-button': isMini
      }"
      :disabled="blockCreateDocument"
      @click="createCorrectionDocument"
    />

    <div
      v-if="isAllCorrectionsWithDocument"
      class="correction-document__success"
    >
      <i class="icon checked" />
      <span>Все корректировки включены в корректировочный документ</span>
    </div>

    <ObModal
      ref="CorrectionNegativeModal"
      :is-show-controls="true"
      :is-read-only="true"
      size="md"
      custom-class="correction-negative-modal"
    >
      <div slot="title">
        <div class="error-modal-title">Итоговая сумма по заказу отрицательная!</div>
        <p>Общая стоимость базовой услуги, дополнительных услуг и корректировок меньше нуля.</p>
        <div class="info-row --first">
          <div class="title">
            Базовая услуга:
          </div>
          <div class="description">
            {{ dataFromService.baseServiceAmount / 100 | currency({ dot: 2 }) }} ₽
          </div>
        </div>
        <div class="info-row">
          <div class="title">
            Дополнительные услуги:
          </div>
          <div class="description">
            {{ dataFromService.addServicesTotal / 100 | currency({ dot: 2 }) }} ₽
          </div>
        </div>
        <div class="info-row">
          <div class="title">
            Корректировки:
          </div>
          <div class="description">
            {{ dataFromService.correctionsTotal / 100 | currency({ dot: 2 }) }} ₽
          </div>
        </div>
        <div class="info-row --last">
          <div class="title">
            Итого:
          </div>
          <div
            class="description"
            :class="{
              '-light-raspberry-red': dataFromService.total < 0
            }"
          >
            {{ dataFromService.total / 100 | currency({ dot: 2 }) }} ₽
          </div>
        </div>
        <ObAlert
          icon="alert"
          text="Создать корректировочный документ можно только при положительной итоговой сумме заказа"
          :hide-close-button="true"
          class="ob-alert-container"
        />
      </div>
    </ObModal>
  </div>
</template>

<script>
import api from '@/api'
import ObButton from 'common-components/src/obComponents/obButton'
import ObAlert from 'common-components/src/obComponents/obAlert'
import ObModal from 'common-components/src/obComponents/obModal'
import { mapActions, mapGetters } from 'vuex'

export default {
  name: 'OrderServicesCorrectionDocument',
  components: {
    ObButton,
    ObModal,
    ObAlert
  },
  props: {
    order: {
      type: Object,
      default: () => {}
    },
    corrections: {
      type: Array,
      default: () => []
    },
    isMini: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      dataFromService: {},
      blockCreateDocument: false
    }
  },
  computed: {
    ...mapGetters({
      isClicar: 'user/isClicar',
      nonFinancialAdjustments: 'order/nonFinancialAdjustments',
      additionalServices: 'order/additionalServices'
    }),
    isCreatingDocument () {
      return this.isClicar && [ ...this.corrections, ...this.currentNonFinancialAdjustment ].some(item => item.status === 'APPROVED' && !item.correctionDocumentNumber) && !this.order.isEditable && !this.isExistSentDocument
    },
    isExistSentDocument () {
      return [ ...this.corrections, ...this.currentNonFinancialAdjustment ].some(item => item.correctionDocument1cStatus === 'SENT')
    },
    isExistOneCorrectionWithDocument () {
      return this.corrections.some(item => item.status !== 'DECLINED' && Boolean(item.correctionDocumentNumber))
    },
    isAllCorrectionsWithDocument () {
      return this.isExistOneCorrectionWithDocument && this.corrections.every(item => item.status === 'DECLINED' || Boolean(item.correctionDocumentNumber))
    },
    currentCorrections () {
      const list = this.order && this.additionalServices ? this.additionalServices[this.order.uuid] || []: []
      return list.filter((item) => item.serviceKind === 'CORRECTION')
    },
    currentNonFinancialAdjustment () {
      return this.order && this.nonFinancialAdjustments ? this.nonFinancialAdjustments[this.order.uuid] || []: []
    },
    currentAdditionalServices () {
      const list = this.order && this.additionalServices ? this.additionalServices[this.order.uuid] || [] : []
      return list.filter((item) => item.serviceKind === 'ADDITIONAL_SERVICE')
    },
  },
  methods: {
    ...mapActions({
      getDataByTab: 'order/getDataByTab'
    }),
    async createCorrectionDocument () {
      this.blockCreateDocument = true
      try {
        await api.orderProcess.createCorrectionDocument({ orderUuid: this.order.uuid })
        this.dataFromService = {}

        this.$notification({
          type: 'system_notification_success',
          message: 'Корректировочный документ успешно отправлен'
        })

        this.getDataByTab()
      } catch (error) {
        if (error.status === 422) {
          this.dataFromService = error
          this.$refs.CorrectionNegativeModal.open()
        } else {
          this.dataFromService = {}
        }
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка создания корректировочного документа'
        })
      } finally {
        this.blockCreateDocument = false
      }
    }
  },
}

</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/mixins';

.correction-document {
  margin-top: 24px;
  &__success {
    height: 61px;
    display: flex;
    align-items: center;
    padding: 0 20px;
    background-color: rgba(0, 243, 198, 0.1);
    .icon {
      font-size: 24px;
      color: $Green-700;
    }
    span {
      margin-left: 20px;
      @include font-mixin(14px, 20px, 400, $color-text-base, 0.2px);
    }
  }

  .--mini-button {
    max-width: 480px;
  }
}

.correction-negative-modal {
  .ob-alert-container {
    margin-bottom: 0!important;
  }

  .error-modal-title {
    margin-bottom: 24px;
    @include font-mixin(28px, 36px, 400, $color-error);
  }

  p {
    @include font-mixin(16px, 20px, 400, $color-text-base, 0.2px);
  }

  .info-row {
    display: flex;
    margin-bottom: 2px;
    @include font-mixin(16px, 20px, 400, $color-text-base, 0.2px);
    .title {
      width: 200px;
      color: $color-grey-label;
    }
    .description {
      width: 140px;
      text-align: right;
    }
    &.--first {
      margin-top: 30px;
    }
    &.--last {
      margin-top: 30px;
      margin-bottom: 30px;
      font-weight: bold;
    }
  }
}
</style>
